/// @cond EO_CXX_EO_IMPL

inline unsigned int elm::genlist_item::subitems_count() const
{
   unsigned int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_subitems_count());
   return _tmp_ret;
}

inline void elm::genlist_item::subitems_clear() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_subitems_clear());
}

inline void elm::genlist_item::promote() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_promote());
}

inline void elm::genlist_item::demote() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_demote());
}

inline void elm::genlist_item::show(Elm_Genlist_Item_Scrollto_Type type_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_show(type_));
}

inline void elm::genlist_item::bring_in(Elm_Genlist_Item_Scrollto_Type type_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_bring_in(type_));
}

inline void elm::genlist_item::all_contents_unset(::efl::eina::list< ::evas::object >* l_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_all_contents_unset(::efl::eolian::to_native<Eina_List **>(l_)));
}

inline void elm::genlist_item::update() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_update());
}

inline void elm::genlist_item::fields_update(::efl::eina::string_view parts_, Elm_Genlist_Item_Field_Type itf_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_fields_update(::efl::eolian::to_c(parts_), itf_));
}

inline void elm::genlist_item::item_class_update(const Elm_Genlist_Item_Class * itc_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_class_update(itc_));
}

inline void elm::genlist_item::decorate_mode_set(::efl::eina::string_view decorate_it_type_, bool decorate_it_set_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_decorate_mode_set(::efl::eolian::to_c(decorate_it_type_), ::efl::eolian::to_c(decorate_it_set_)));
}

inline ::elm::widget_item elm::genlist_item::prev_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_prev_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::genlist_item::next_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_next_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::genlist_item::parent_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_parent_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::efl::eina::crange_list< ::elm::widget_item > elm::genlist_item::subitems_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_subitems_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline bool elm::genlist_item::selected_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_selected_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::genlist_item::selected_set(bool selected_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_selected_set(::efl::eolian::to_c(selected_)));
}

inline bool elm::genlist_item::expanded_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_expanded_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::genlist_item::expanded_set(bool expanded_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_expanded_set(::efl::eolian::to_c(expanded_)));
}

inline int elm::genlist_item::expanded_depth_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_expanded_depth_get());
   return _tmp_ret;
}

inline const Elm_Genlist_Item_Class * elm::genlist_item::item_class_get() const
{
   const Elm_Genlist_Item_Class * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_class_get());
   return _tmp_ret;
}

inline int elm::genlist_item::index_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_index_get());
   return _tmp_ret;
}

inline ::efl::eina::string_view elm::genlist_item::decorate_mode_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_decorate_mode_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool elm::genlist_item::flip_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_flip_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::genlist_item::flip_set(bool flip_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_flip_set(::efl::eolian::to_c(flip_)));
}

inline Elm_Object_Select_Mode elm::genlist_item::select_mode_get() const
{
   Elm_Object_Select_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_select_mode_get());
   return _tmp_ret;
}

inline void elm::genlist_item::select_mode_set(Elm_Object_Select_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_select_mode_set(mode_));
}

inline Elm_Genlist_Item_Type elm::genlist_item::type_get() const
{
   Elm_Genlist_Item_Type _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_type_get());
   return _tmp_ret;
}

inline unsigned int eo_cxx::elm::genlist_item::subitems_count() const
{
   unsigned int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_subitems_count());
   return _tmp_ret;
}

inline void eo_cxx::elm::genlist_item::subitems_clear() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_subitems_clear());
}

inline void eo_cxx::elm::genlist_item::promote() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_promote());
}

inline void eo_cxx::elm::genlist_item::demote() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_demote());
}

inline void eo_cxx::elm::genlist_item::show(Elm_Genlist_Item_Scrollto_Type type_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_show(type_));
}

inline void eo_cxx::elm::genlist_item::bring_in(Elm_Genlist_Item_Scrollto_Type type_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_bring_in(type_));
}

inline void eo_cxx::elm::genlist_item::all_contents_unset(::efl::eina::list< ::evas::object >* l_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_all_contents_unset(::efl::eolian::to_native<Eina_List **>(l_)));
}

inline void eo_cxx::elm::genlist_item::update() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_update());
}

inline void eo_cxx::elm::genlist_item::fields_update(::efl::eina::string_view parts_, Elm_Genlist_Item_Field_Type itf_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_fields_update(::efl::eolian::to_c(parts_), itf_));
}

inline void eo_cxx::elm::genlist_item::item_class_update(const Elm_Genlist_Item_Class * itc_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_class_update(itc_));
}

inline void eo_cxx::elm::genlist_item::decorate_mode_set(::efl::eina::string_view decorate_it_type_, bool decorate_it_set_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_decorate_mode_set(::efl::eolian::to_c(decorate_it_type_), ::efl::eolian::to_c(decorate_it_set_)));
}

inline ::elm::widget_item eo_cxx::elm::genlist_item::prev_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_prev_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::genlist_item::next_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_next_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::genlist_item::parent_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_parent_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::efl::eina::crange_list< ::elm::widget_item > eo_cxx::elm::genlist_item::subitems_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_subitems_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline bool eo_cxx::elm::genlist_item::selected_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_selected_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::genlist_item::selected_set(bool selected_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_selected_set(::efl::eolian::to_c(selected_)));
}

inline bool eo_cxx::elm::genlist_item::expanded_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_expanded_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::genlist_item::expanded_set(bool expanded_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_expanded_set(::efl::eolian::to_c(expanded_)));
}

inline int eo_cxx::elm::genlist_item::expanded_depth_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_expanded_depth_get());
   return _tmp_ret;
}

inline const Elm_Genlist_Item_Class * eo_cxx::elm::genlist_item::item_class_get() const
{
   const Elm_Genlist_Item_Class * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_class_get());
   return _tmp_ret;
}

inline int eo_cxx::elm::genlist_item::index_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_index_get());
   return _tmp_ret;
}

inline ::efl::eina::string_view eo_cxx::elm::genlist_item::decorate_mode_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_decorate_mode_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool eo_cxx::elm::genlist_item::flip_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_flip_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::genlist_item::flip_set(bool flip_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_flip_set(::efl::eolian::to_c(flip_)));
}

inline Elm_Object_Select_Mode eo_cxx::elm::genlist_item::select_mode_get() const
{
   Elm_Object_Select_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_select_mode_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::genlist_item::select_mode_set(Elm_Object_Select_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_item_select_mode_set(mode_));
}

inline Elm_Genlist_Item_Type eo_cxx::elm::genlist_item::type_get() const
{
   Elm_Genlist_Item_Type _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_type_get());
   return _tmp_ret;
}

inline ::eo_cxx::elm::genlist_item::operator ::elm::genlist_item() const
{
   return *static_cast<::elm::genlist_item const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::genlist_item::operator ::elm::genlist_item&()
{
   return *static_cast<::elm::genlist_item*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::genlist_item::operator ::elm::genlist_item const&() const
{
   return *static_cast<::elm::genlist_item const*>(static_cast<void const*>(this));
}

template <typename T>
unsigned int elm_genlist_item_subitems_count_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->subitems_count();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         unsigned int _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_genlist_item_subitems_clear_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->subitems_clear();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_genlist_item_promote_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->promote();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_genlist_item_demote_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->demote();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_genlist_item_show_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Genlist_Item_Scrollto_Type type_)
{
   try
      {
         static_cast<T*>(self->this_)->show(type_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_genlist_item_bring_in_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Genlist_Item_Scrollto_Type type_)
{
   try
      {
         static_cast<T*>(self->this_)->bring_in(type_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_genlist_item_all_contents_unset_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_List ** l_)
{
   try
      {
         static_cast<T*>(self->this_)->all_contents_unset(::efl::eolian::to_cxx<::efl::eina::list< ::evas::object >*>(l_, std::tuple<std::true_type, std::true_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_genlist_item_update_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->update();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_genlist_item_fields_update_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * parts_, Elm_Genlist_Item_Field_Type itf_)
{
   try
      {
         static_cast<T*>(self->this_)->fields_update(::efl::eolian::to_cxx<::efl::eina::string_view>(parts_, std::tuple<std::false_type>()), itf_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_genlist_item_item_class_update_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const Elm_Genlist_Item_Class * itc_)
{
   try
      {
         static_cast<T*>(self->this_)->item_class_update(itc_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_genlist_item_decorate_mode_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * decorate_it_type_, Eina_Bool decorate_it_set_)
{
   try
      {
         static_cast<T*>(self->this_)->decorate_mode_set(::efl::eolian::to_cxx<::efl::eina::string_view>(decorate_it_type_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<bool>(decorate_it_set_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::elm::widget_item elm_genlist_item_prev_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->prev_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_genlist_item_next_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->next_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_genlist_item_parent_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->parent_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::efl::eina::crange_list< ::elm::widget_item > elm_genlist_item_subitems_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->subitems_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const Eina_List * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }
}

template <typename T>
bool elm_genlist_item_selected_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->selected_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_genlist_item_selected_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool selected_)
{
   try
      {
         static_cast<T*>(self->this_)->selected_set(::efl::eolian::to_cxx<bool>(selected_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_genlist_item_expanded_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->expanded_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_genlist_item_expanded_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool expanded_)
{
   try
      {
         static_cast<T*>(self->this_)->expanded_set(::efl::eolian::to_cxx<bool>(expanded_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
int elm_genlist_item_expanded_depth_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->expanded_depth_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         int _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
const Elm_Genlist_Item_Class * elm_genlist_item_item_class_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->item_class_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const Elm_Genlist_Item_Class * _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
int elm_genlist_item_index_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->index_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         int _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
::efl::eina::string_view elm_genlist_item_decorate_mode_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->decorate_mode_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
bool elm_genlist_item_flip_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->flip_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_genlist_item_flip_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool flip_)
{
   try
      {
         static_cast<T*>(self->this_)->flip_set(::efl::eolian::to_cxx<bool>(flip_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_Object_Select_Mode elm_genlist_item_select_mode_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->select_mode_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Object_Select_Mode _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_genlist_item_select_mode_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Object_Select_Mode mode_)
{
   try
      {
         static_cast<T*>(self->this_)->select_mode_set(mode_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_Genlist_Item_Type elm_genlist_item_type_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->type_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Genlist_Item_Type _tmp_ret{};
         return _tmp_ret;
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::genlist_item >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::widget_item >::template type<T>
   {
      virtual unsigned int subitems_count()
      {
         unsigned int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_item_subitems_count());
            return _tmp_ret;
      }

      virtual void subitems_clear()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_item_subitems_clear());
      }

      virtual void promote()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_item_promote());
      }

      virtual void demote()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_item_demote());
      }

      virtual void show(Elm_Genlist_Item_Scrollto_Type type_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_item_show(type_));
      }

      virtual void bring_in(Elm_Genlist_Item_Scrollto_Type type_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_item_bring_in(type_));
      }

      virtual void all_contents_unset(::efl::eina::list< ::evas::object >* l_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_item_all_contents_unset(::efl::eolian::to_native<Eina_List **>(l_)));
      }

      virtual void update()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_item_update());
      }

      virtual void fields_update(::efl::eina::string_view parts_, Elm_Genlist_Item_Field_Type itf_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_item_fields_update(::efl::eolian::to_c(parts_), itf_));
      }

      virtual void item_class_update(const Elm_Genlist_Item_Class * itc_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_item_class_update(itc_));
      }

      virtual void decorate_mode_set(::efl::eina::string_view decorate_it_type_, bool decorate_it_set_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_item_decorate_mode_set(::efl::eolian::to_c(decorate_it_type_), ::efl::eolian::to_c(decorate_it_set_)));
      }

      virtual ::elm::widget_item prev_get()
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_item_prev_get());
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item next_get()
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_item_next_get());
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item parent_get()
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_item_parent_get());
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::efl::eina::crange_list< ::elm::widget_item > subitems_get()
      {
         const Eina_List * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_item_subitems_get());
            return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }

      virtual bool selected_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_item_selected_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void selected_set(bool selected_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_item_selected_set(::efl::eolian::to_c(selected_)));
      }

      virtual bool expanded_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_item_expanded_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void expanded_set(bool expanded_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_item_expanded_set(::efl::eolian::to_c(expanded_)));
      }

      virtual int expanded_depth_get()
      {
         int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_item_expanded_depth_get());
            return _tmp_ret;
      }

      virtual const Elm_Genlist_Item_Class * item_class_get()
      {
         const Elm_Genlist_Item_Class * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_item_class_get());
            return _tmp_ret;
      }

      virtual int index_get()
      {
         int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_item_index_get());
            return _tmp_ret;
      }

      virtual ::efl::eina::string_view decorate_mode_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_item_decorate_mode_get());
            return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool flip_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_item_flip_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void flip_set(bool flip_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_item_flip_set(::efl::eolian::to_c(flip_)));
      }

      virtual Elm_Object_Select_Mode select_mode_get()
      {
         Elm_Object_Select_Mode _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_item_select_mode_get());
            return _tmp_ret;
      }

      virtual void select_mode_set(Elm_Object_Select_Mode mode_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_item_select_mode_set(mode_));
      }

      virtual Elm_Genlist_Item_Type type_get()
      {
         Elm_Genlist_Item_Type _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_item_type_get());
            return _tmp_ret;
      }

   };
};


template<>
struct operation_description_class_size< ::elm::genlist_item >
{
   static constexpr int value = 
#if defined(GENLIST_ITEM_PROTECTED) && defined(GENLIST_ITEM_BETA)
      28
#elif defined(GENLIST_ITEM_PROTECTED)
      28
#elif defined(GENLIST_ITEM_BETA)
      28
#else
      28
#endif
      + operation_description_class_size<::elm::widget_item >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::genlist_item>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_subitems_count_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_subitems_count);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_subitems_clear_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_subitems_clear);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_promote_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_promote);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_demote_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_demote);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_show_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_show);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_bring_in_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_bring_in);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_all_contents_unset_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_all_contents_unset);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_update_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_update);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_fields_update_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_fields_update);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_item_class_update_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_class_update);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_decorate_mode_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_decorate_mode_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_prev_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_prev_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_next_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_next_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_parent_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_parent_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_subitems_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_subitems_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_selected_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_selected_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_selected_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_selected_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_expanded_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_expanded_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_expanded_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_expanded_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_expanded_depth_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_expanded_depth_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_item_class_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_class_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_index_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_index_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_decorate_mode_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_decorate_mode_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_flip_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_flip_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_flip_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_flip_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_select_mode_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_select_mode_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_select_mode_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_select_mode_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_type_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_type_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::widget_item>(), &ops[operation_description_class_size< ::elm::genlist_item >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::genlist_item>)
{
   return (ELM_GENLIST_ITEM_CLASS);
}

} } }

/// @endcond

